/*
 * Stuff that is needed all over the place.
 */

#ifndef HR_DEFINES
#define HR_DEFINES

/* Defines the size for temp[] arrays used here and there...*/
#define HR_BUFFER_SIZE 1024

/* These are usually needed */
#define FONT8X8   "font8x8.pbm"
#define PTRBITMAP "pointer.gif"

/* Used in some places to scale up integers. DO NOT CHANGE!*/
#define SCALE 16

/* Just to make sure these are defined...*/
#define   MIN(a,b)   ((a < b)?(a):(b))
#define   MAX(a,b)   ((a > b)?(a):(b))
/* Distance between two points. (taken from angband). */
#define DISTANCE(x1, y1, x2, y2) \
   (( ((abs((y1) - (y2)) + abs((x1) - (x2))) << 1) - \
   ( (abs((y1) - (y2)) > abs((x1) - (x2))) ? abs((x1) - (x2)) : \
   abs((y1) - (y2)))) >> 1)


/* Puts 4 unsigned chars into an int */
#define CHARS2INT(a) ((unsigned int)((((unsigned char)(*(a+3)))<<24)| \
                                     (((unsigned char)(*(a+2)))<<16)| \
                                     (((unsigned char)(*(a+1)))<<8)| \
                                     (((unsigned char)(*(a  ))))))

/* Centers a line of text. */
#define HR_CENTER(x,y,color,bcolor,text,font,flags) \
      hr_write((x)-hr_string_xpixels(text,font, \
												 STRING_START,STRING_END,flags)/2,y, \
					color,bcolor,text,font,STRING_START,STRING_END,flags)

/* width/height of a window/button */
#define HR_WIDTH(p)  (((p)->zone->x2)-((p)->zone->x1)+1)
#define HR_HEIGHT(p) (((p)->zone->y2)-((p)->zone->y1)+1)

/* Converts radians to degrees and vise versa.*/
#define DEG2RAD(a) (((a)*2*M_PI)/360.0)
#define RAD2DEG(a) (((a)*360.0)/(2*M_PI))


/* For checking mouse keys.*/
#define HR_LMB (hr_mouse.button & MOUSE_LEFTBUTTON)
#define HR_MMB (hr_mouse.button & MOUSE_MIDDLEBUTTON)
#define HR_RMB (hr_mouse.button & MOUSE_RIGHTBUTTON)
/* Mouse flags*/
#define MOUSE_STAYS_ON_TOP		1
#define MOUSE_CENTER          2

/* Some names for true/false to keep source nicer looking.*/
#define YES           1
#define NO            0
/* Flags NONE...*/
#define NONE          0

/*Some global flags*/
#define HR_SOUND_INITIALIZED 1

/*Flags buttons */
#define BUTTON_ENABLED             1
#define BUTTON_SWITCH              2
#define BUTTON_PRESSED             4
#define BUTTON_INVISIBLE           8
#define BUTTON_ACCEPTS_INPUT       16
#define BUTTON_HSLIDER             32
#define BUTTON_VSLIDER             64
#define BUTTON_HOTKEY_PRESSED      128
/*256 unused*/
#define BUTTON_NO_TAB_CYCLE        512
#define BUTTON_DEFAULT_BUTTON      1024
#define BUTTON_HILITE              2048
#define BUTTON_NO_DELAY            4096
#define BUTTON_STRING_EDITED       8192
#define BUTTON_MENUITEM				  16384
#define BUTTON_IGNORE_ENABLED_FLAG 32768

/* Slider flags */
#define SLIDER_XNEG         1
#define SLIDER_YNEG         2
#define SLIDER_GET_XVALINT  4
#define SLIDER_GET_YVALINT  8
#define SLIDER_SET_XVALINT  16
#define SLIDER_SET_YVALINT  32

/* Flags for bitmaps etc */
#define GFX_MONO            1
#define GFX_COLOR           2
#define GFX_24BPALETTE      4
#define GFX_COMPILED        8
#define GFX_SINGLECOLBGR    16
#define GFX_INCLUDEZERO     32
#define GFX_BRITEST         64
#define GFX_DARKEST         128
#define GFX_NOBMAPPALETTE   256
#define GFX_XOR             512
#define GFX_OR              1024
#define GFX_AND             2048
#define GFX_NOT             4096
#define GFX_USE_FILLPATTERN 8192
#define GFX_FAST            16384

/* Font constants */
#define FONT_DEFAULT_INDEX           0
#define FONT_DEFAULT_SCALED_WIDTH    16
#define FONT_DEFAULT_SCALED_HEIGHT   22
#define FONT_DEFAULT_X_OFFSET        0
#define FONT_DEFAULT_Y_OFFSET        0
#define FONT_DEFAULT_ROTATE_ANGLE    22
#define FONT_DEFAULT_ITALICS_FACTOR  0.5
#define FONT_DEFAULT_X_MULTIPLIER    -1.0
#define FONT_DEFAULT_Y_MULTIPLIER    -1.0
/* Do no select '\' as FONT_FORMATCHAR */
#define FONT_TOGGLECHAR    '~'
#define FONT_FORMATCHAR    '^'

/* Font func flags */
#define FONT_MONO          GFX_MONO
#define FONT_COLOR         GFX_COLOR
#define FONT_UNDERLINED    4
#define FONT_REVERSE       8
#define FONT_SINGLECOLBGR  16
#define FONT_BOLD          32
#define FONT_ITALICS       128
#define FONT_ROTATED       256
#define FONT_XMULTIPLIED   512
#define FONT_YMULTIPLIED   1024
#define FONT_PROPORTIONAL  2048
#define FONT_SCALED        4096
#define FONT_INVISIBLE     8192
#define FONT_UNFORMATTED   16384

/* String func flags.*/
#define STRING_TOGGLESEQ   -1
#define STRING_FORMATSEQ   -2
#define STRING_END         -3
#define STRING_START       0
#define STRING_RIGHT       1
#define STRING_LEFT        2

/* Zones */
#define ZONE_ENABLED     1
#define ZONE_GADGET      2
#define ZONE_WINDOW      4
#define ZONE_MENU        8
#define ZONE_WRAPSCROLL  16
#define ZONE_VALUEGADGET 32

/* Windows. */
#define WINDOW_STORED				1
#define WINDOW_NOBORDER				4
#define WINDOW_INNERBOX				8
#define WINDOW_ROOT              16 /* Not used yet*/
#define WINDOW_CLIPPING          32


/* Input handler */
#define LMB_PRESSED    1
#define LMB_RELEASED   2
#define MMB_PRESSED    4
#define MMB_RELEASED   8
#define RMB_PRESSED    16
#define RMB_RELEASED   32
#define AMB_PRESSED    64
#define AMB_RELEASED   128
#define KBD_PRESSED    256
#define KBD_RELEASED   512
#define NO_EDITING     2048
#define WAIT_EVENT     4096
#define IGNORE_HOTKEYS 8192


/* Menu flags*/
#define MENU_ENABLED				1
#define MENU_FORCE_SIZE			2
#define MENU_FORCE_LOCATION	4
#define MENU_HORIZONTAL			8


/* Bob defines*/
#define BOB_INIT        0
#define BOB_INITONLY    1
#define BOB_SMART       2
#define BOB_DUMB        3
#define BOB_REMOVE      4
#define BOB_REMOVEONLY  5
#define BOB_NOIMG       6
/* Bob flags */
#define BOB_INITIALIZED 128
#define BOB_NO_TEMPMAP  256
#define BOB_REINIT_ME   512

/* These are hr_update_button() */
#define UPDATE_GFXONLY   0
#define UPDATE_INDEX     1
#define UPDATE_FLAGS     2
#define UPDATE_FONT      3
#define UPDATE_COLORS    4
#define UPDATE_TEXT      5
#define UPDATE_TEXT2     6
#define UPDATE_BITMAP    7
#define UPDATE_BITMAP2   8
#define UPDATE_X1        9
#define UPDATE_Y1        10
#define UPDATE_X2        11
#define UPDATE_Y2        12
#define UPDATE_PARENT    13
#define UPDATE_HOTKEY    14
#define UPDATE_EXTRAS    15

/* Screen flags*/
#define SCREEN_VIRTUAL					1
#define SCREEN_NOCLIP					2 
#define SCREEN_VIRTUALONLY				4
#define SCREEN_HAS_MASK					8
#define SCREEN_HAS_SIMPLEMASK			32
#define SCREEN_STORE_PALETTE		   64
#define SCREEN_GET_PALETTE				128
#define SCREEN_STORE_TO_TEMP			256
#define SCREEN_GET_FROM_TEMP			512
#define SCREEN_DELETE_TEMP				1024
#define SCREEN_COPY_FROM_PHYSICAL	2048
#define SCREEN_COPY_TO_PHYSICAL		4096

/* Color flags */
#define COLOR_USED       1
#define COLOR_SHIFT_DOWN 2
#define COLOR_SHIFT_UP   4
#define COLOR_PALETTE_STORED 16384

/* Color structs are filled with this color initially.*/
#define COLOR_DEFAULT    1

/* Color names for indexes */
#define COLOR_BACKGROUND 0
#define COLOR_FOREGROUND 1
#define COLOR_DARK       2
#define COLOR_LIGHT      3
#define COLOR_HILITE     4
#define COLOR_RAISED     5
#define COLOR_PRESSED    6
#define COLOR_UNDEFINED  7

/* Sound */
#ifdef SOUND_SUPPORT
#define HR_SOUND_DEVICE      "/dev/dsp"
#define HR_SOUND_MAX_SAMPLES 4
#define HR_SOUND_SAMPLE_RATE 11000
#define HR_SOUND_CHANNELS    4
#endif

#endif
